##
# @brief CPPDU (Transport Frame) Operations Message class.
# @author Miguel Dominguez
# @details There is no superclass for Operations Messages Classes because
# they basically have nothing in common, they are simply a container for
# some useful variables to be passed forward.
# @date 2016
class CPPDUOpsMsg(object):

   ##
   # @fn __init__
   # @brief Constructor.
   # @details Initializes the message states to sane defaults
   def __init__(self):
      self.hasCrcErrors = False

   ##
   # @fn setisNewTransportFrame
   # @brief Report whether the current Transport Frame contains CRC errors
   # @param[in] hasCrCErrors Whether the current Transport Frame contains
   # CRC errors
   # @warning Should probably not use getters and setters in Python
   def setHasCrcErrors(self,hasCrcErrors):
      self.hasCrcErrors = hasCrcErrors

   ##
   # @fn getisNewTransportFrame
   # @brief Report whether the current Transport Frame contains CRC errors
   # @param[out] hasCrCErrors Whether the current Transport Frame contains
   # CRC errors
   # @warning Should probably not use getters and setters in Python
   def getHasCrcErrors(self):
      return self.hasCrcErrors
