#!/usr/bin/env python
# -*- coding: utf-8 -*-
# 
# Copyright 2016 The Aerospace Corporation.
# 
# This is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
# 

# must use Qt
from traits.trait_base import ETSConfig
ETSConfig.toolkit = 'qt4'

import traits.api as tr
import traitsui.api as trui

from pyface.qt.QtCore import QFileSystemWatcher

class QFSWatcher(tr.HasTraits):
    """Watch directories for changes and triggers events"""
    watcher = tr.Instance(QFileSystemWatcher, ())
    changed = tr.Event
    
    def __init__(self, *args, **kwds):
        super(QFSWatcher, self).__init__(*args, **kwds)

        # this assumes watched names a directory
        self.watcher.directoryChanged.connect(self.signal_to_changed)

    # interfaces bare signal to trait event
    def signal_to_changed(self, new): self.changed = new

    # use full handler routine signature to get old and new dirs
    def update_watcher(self, obj, name, old, new):
        #print "Remove", old, "Add", new
        self.watcher.removePath(old)
        self.watcher.addPath(new)
        self.changed = new
